import { test, expect } from '@playwright/test';
import {ProductStateTrainer} from "./ProductStateTrainer";
test.describe('Test Check Equal of Innerstates', () => {

  test("Test invalid input for equal checking", async()=> {
    const gamesystem = ProductStateTrainer.givenFullProductGamesystemWithTwoStates();
    expect(gamesystem.states[0].equalInnerStates(null)).toBeFalsy();
    expect(gamesystem.states[0].equalInnerStates(undefined)).toBeFalsy();
  })

  test("Test empty input for equal checking", async ()=> {
    const gamesystem = ProductStateTrainer.givenFullProductGamesystemWithTwoStates();
    expect(gamesystem.states[0].equalInnerStates([])).toBeFalsy();
  })

  test("Test identical inner states for equal", async ()=> {
    const gamesystem = ProductStateTrainer.givenFullProductGamesystemWithTwoStates();
    expect(gamesystem.states[0].equalInnerStates(gamesystem.states[0].innerStates)).toBeTruthy();
  })

  test("Test slightly derivating inner states for Equal", async ()=> {
    const gamesystem = ProductStateTrainer.givenFullProductGamesystemWithTwoStates();
    expect(gamesystem.states[0].equalInnerStates(gamesystem.states[1].innerStates)).toBeFalsy();
  })
});
